DECLARE SUB GasIt (Gasx!)
' ===========================================================================
'
' UIDEMO.BAS Copyright (c) 1989 Microsoft Corporation
'
' ===========================================================================
' ===========================================================================
' Decls, includes, and dimensions
' ===========================================================================
DEFINT A-Z
'$INCLUDE: 'general.bi'
'$INCLUDE: 'mouse.bi'
'$INCLUDE: 'menu.bi'
'$INCLUDE: 'window.bi'
'$INCLUDE: 'CFDECS.bi'

DIM GloTitle(MAXMENU)           AS MenuTitleType
DIM GloItem(MAXMENU, MAXITEM)   AS MenuItemType
DIM GloWindow(MAXWINDOW)        AS windowType
DIM GloButton(MAXBUTTON)        AS buttonType
DIM GloEdit(MAXEDITFIELD)       AS EditFieldType
DIM GloWindowStack(MAXWINDOW)   AS INTEGER
DIM GloBuffer$(MAXWINDOW + 1, 2)


    ' =======================================================================
    ' Initialize Demo
    ' =======================================================================
    CLS
    MenuInit
    WindowInit
    MouseShow
    SetupFileNameT$ = "CFCONS.CON"
    CALL LoadConstants         'load mux channel variable names and constants
    CALL TIMEX(-1)        'INITIALIZE TIMEX
    GOSUB LoadColors      'to load up the screen color matrix
    NumberOfSamples = 100   'Samples to Average
    TimerInterval% = 10
    DisplayOnFlag = 1
    WriteDiskOnFlag = 0
    LptOnFlag = 0
    LptHeadingDo = 0
    PlotOnFlag = 1
    RandomOnFlag = 0
    DisplayIntervalVal = 60
    LptIntervalVal = 360
    PlotIntervalVal = 60
    WriteDiskIntervalVal = 60
    CellBalanceTimeVal = 1200
    GasIntervalVal = 10
    RandomIntervalVal& = 0
    PowerOutOfCal! = 2.0065'0785'7.776'8.4211'8.406'8.594
    Gasx! = 5
    FineRampRate! = -.007044'*.946=amps per 10 sec
    FineRampMax! = -.845   '*.946 = amps
    FineRampMin! = -.127 '*.946=amps
    TempRate! = -.0005555
    TempMin! = -2.8372
    HiLoIntervalVal& = 21600'change time in seconds
    HiValue! = -.845'*.946=amps
    LoValue! = -.127'*.946=amps
    AutoTrackOnFlag% = 0
    GasOnFlag = 0
    SetupMenu
    ON TIMER(TimerInterval%) GOSUB WorkLoop
    DiskNameForLog$ = "a:testdat.dat"
    LogFileName$ = "920601.dat"
    TXXX% = 1
    ' =======================================================================
    ' Show Opening alert window
    ' =======================================================================

         
          A$ = "The Mark II Cold Fusion Calorimeter|"
          A$ = A$ + "Test Program|"
          A$ = A$ + "Welcomes You!|"
          A$ = A$ + "An EGA Color Monitor Is Required|"
    x = Alert(4, A$, 9, 10, 14, 70, "EGA Color", "Exit", "")

    IF x = 1 THEN
        DisplayType = TRUE
        ColorDisplay
    ELSE
        END
    END IF

    ' =======================================================================
    ' Main Loop : Stay in loop until DemoFinished set to TRUE
    ' =======================================================================
    DemoFinished = FALSE

    WHILE NOT DemoFinished
        kbd$ = MenuInkey$
        WHILE MenuCheck(2)
            GOSUB MenuTrap

        WEND
    WEND

    ' =======================================================================
    ' End Program
    ' =======================================================================

    MouseHide
    COLOR 15, 0
    CLS
    CLOSE #1
    END


' ===========================================================================
' If a menu event occured, call the proper demo, or if Exit, set demoFinished
' ===========================================================================

MenuTrap:
    menu = MenuCheck(0)
    item = MenuCheck(1)
   
    SELECT CASE menu
        CASE 1
            SELECT CASE item
                CASE 1: GOSUB ContinueRun
                CASE 3: GOSUB StartRun
                CASE 4: GOSUB EndRun
                CASE 5: GOSUB ChangeDisk
                CASE 10: DemoFinished = TRUE
            END SELECT
        CASE 2
            SELECT CASE item
                CASE 1: SaveConstants
                CASE 2: CALL ModifyConstants(MUXNAME$(), MUXCON!())
                CASE 3: LoadNewConstants
                CASE 4: SetupFileName
                CASE 5: GOSUB PlotDataSave
                CASE 6: GOSUB RestorePlotData
                END SELECT
        CASE 3
            SELECT CASE item
                CASE 1:
                        IF RandomOnFlag = 0 THEN
                           RandomOnFlag = 1
                           CALL GetNumber("Power Change-Seconds", Acy!)
                           RandomIntervalVal& = Acy!
                        ELSE RandomOnFlag = 0
                             RandomIntervalVal& = 0
                        END IF
                        SetupMenu
                CASE 2: LoadMatrix
                CASE 3: GOSUB PrintMuxLabels
                CASE 4 'zero Joul sum
                        LastEvents!(69, 0) = 0
                CASE 5: DisplayType = FALSE
                CASE 6  'Invert Cell Current
                        PowerBeforeInversion! = LastEvents!(64, 0)'remember power level before inversion
                        TimeOfInversion& = TimeInSeconds&'remember time of inversion
                        'CellBalanceFlag = 1
                        MUXCON!(73, 0) = -MUXCON!(73, 0)'invert current
                        MUXCON!(76, 0) = -MUXCON!(76, 0)'invert drive offset
                        AllDACLoad
                        'CALL TIMEX(50) 'wait ten seconds
                        'READALL        'get new set of values
                        'GOSUB CellBalance  'balance it
                CASE 7  'Adjust PowerOutOfCal!
                        CALL GetNumber("Refrigerator Power", Acy!)
                        PowerOutOfCal! = Acy!
                CASE 8: LastEvents!(69, 0) = 0'reset net joule accumulation
                CASE 9:
                 Quit = 0
                 DO UNTIL Quit = 1
                    CALL GasIt(Gasx!)
                    KEYX$ = INKEY$
                    IF KEYX$ = CHR$(27) THEN Quit = 1
                    IF KEYX$ = (CHR$(0) + CHR$(67)) THEN Quit = 1  'ESCAPE OR F9
                 LOOP
                        LOCATE 10, 1
                        INPUT "Enter Gas Value  "; Gasx!
                        LastEvents!(70, 0) = Gasx!
                        StepCount! = 70 * Gasx!
                CASE 10:
                        IF SawTooth% = 0 THEN SawTooth% = 1 ELSE SawTooth% = 0
                        HiLo% = 0
                CASE 11
                        IF HiLo% = 0 THEN HiLo% = 1 ELSE HiLo% = 0
                        SawTooth% = 0
                END SELECT
        CASE 4
            SELECT CASE item
            CASE 1: IF LptOnFlag = 0 THEN LptOnFlag = 1 ELSE LptOnFlag = 0
            CASE 2: IF WriteDiskOnFlag = 0 THEN WriteDiskOnFlag = 1 ELSE WriteDiskOnFlag = 0: CLOSE #1
            IF WriteDiskOnFlag = 1 THEN
            CLOSE #1
            DiskNameForLog$ = ""
            fileName$ = ""
            CALL GetLiteral("EnterDriveAndFileName", DiskNameForLog$)
            CALL CheckMainFileName(DiskNameForLog$, fileName$, fileExt$)
            IF fileName$ = "" THEN
            WriteDiskOnFlag = 0
            LogFileName$ = ""
            ELSE
            LogFileName$ = fileName$ + ".DAT"
            OPEN LogFileName$ FOR RANDOM AS #1 LEN = LEN(kk)
            TXXX% = 1
            BytesWritten& = 0
            END IF
            END IF
            IF WriteDiskOnFlag = 0 THEN
            CLOSE #1
            LogFileName$ = ""
            END IF
            CASE 3: IF DisplayOnFlag = 0 THEN DisplayOnFlag = 1 ELSE DisplayOnFlag = 0
            CASE 4: IF PlotOnFlag = 0 THEN PlotOnFlag = 1 ELSE PlotOnFlag = 0
            CASE 5: GOSUB EnterComment
            CASE 6: IF GasOnFlag = 0 THEN GasOnFlag = 1 ELSE GasOnFlag = 0
            CASE 7: IF AutoTrackOnFlag = 0 THEN AutoTrackOnFlag = 1 ELSE AutoTrackOnFlag = 0
            CASE 8
            IF FastGas% = 0 THEN
            FastGas% = 1
            OPEN "B:FG" FOR OUTPUT AS #3
            LOCATE 10, 1
            INPUT "Enter Three Variables to Track"; FG1, FG2, FG3
            ELSE
            CLOSE #3
            FastGas% = 0
            END IF
            END SELECT
            SetupMenu
        CASE 5 ' Analyze Date Here
        CASE 6
             SELECT CASE item
                CASE 1: DACChannelSetup
                CASE 2: AllDACLoad
             END SELECT
        CASE 7
            SELECT CASE item
                CASE 1: SamplesToAverage
                CASE 2: GOSUB DisplayIntervalSet
                CASE 3: GOSUB PlotIntervalSet
                CASE 4: GOSUB WriteDiskIntervalSet
                CASE 5: GOSUB LptIntervalSet
                CASE 6: GOSUB CellBalanceTimeSet
                CASE 7: GOSUB GasIntervalSet
                CASE ELSE
            END SELECT
            SetupMenu
        CASE ELSE
    END SELECT
    SetupMenu
    CLS
    MenuShow
    MouseShow
RETURN
LoadColors:
REDIM ScreenColors$(1 TO 16)
ScreenColors$(1) = "Black"
ScreenColors$(2) = "Blue"
ScreenColors$(3) = "Green"
ScreenColors$(4) = "Cyan"
ScreenColors$(5) = "Red"
ScreenColors$(6) = "Magenta"
ScreenColors$(7) = "Brown"
ScreenColors$(8) = "DoNotUse"
ScreenColors$(9) = "Gray"
ScreenColors$(10) = "Light Blue"
ScreenColors$(11) = "Light Green"
ScreenColors$(12) = "Light Cyan"
ScreenColors$(13) = "Light Red"
ScreenColors$(14) = "Light Magenta"
ScreenColors$(15) = "Yellow"
ScreenColors$(16) = "Bright White"

RETURN

StartRun:   
                 OPEN LogFileName$ FOR RANDOM AS #1 LEN = LEN(kk)
                 AllDACLoad  'load the constants to start run
ContinueRun:     TIMER ON
                 WIDTH 80, 43
                 IF DisplayType = TRUE THEN
                 SCREEN 9
                 COLOR 7
                 ELSE
                 SCREEN 10
                 END IF
                 Quit = 0
                 PRINTADC
                 PutPlotsUp
                 LastTime! = TIMER
                 DO UNTIL Quit = 1
                    KEYX$ = INKEY$
                    IF KEYX$ = CHR$(27) THEN Quit = 1
                    IF KEYX$ = (CHR$(0) + CHR$(67)) THEN Quit = 1  'ESCAPE OR F9
                    GOSUB ScheduleExecute
                 LOOP
                 SCREEN 0
                 RETURN

EndRun:          SCREEN 0
                 TIMER OFF
                 CLOSE #1
                 WriteDiskOnFlag = 0
                 RETURN
ChangeDisk:
            CLOSE #1
            BEEP
ChangeDiskx: CALL GetLiteral("New File Name ", Axt$)
            IF Axt$ = "" THEN
            ELSE
            LogFileName$ = "A:" + Axt$ + ".DAT"
            END IF
            LOCATE 42, 1
            CALL GetLiteral("Enter Y if OK", Axt$)
            IF Axt$ = "Y" OR Axt$ = "y" THEN
            INPUT "Hit enter after replacing disk"; foox
            OPEN LogFileName$ FOR RANDOM AS #1 LEN = LEN(kk)
            TXXX% = 1
            BytesWritten& = 0
            ELSE
            GOTO ChangeDiskx
            END IF
                 RETURN
WorkLoop:
TimeInSeconds& = TimeInSeconds& + 10
IF Quit = 1 THEN RETURN


IF DisplayIntervalVal <> 0 THEN
IF TimeInSeconds& MOD DisplayIntervalVal = 0 THEN
DisplayIntervalDo = DisplayOnFlag
END IF
END IF

IF PlotIntervalVal <> 0 THEN
IF TimeInSeconds& MOD PlotIntervalVal = 0 THEN
PlotIntervalDo = PlotOnFlag
END IF
END IF


IF LptIntervalVal <> 0 THEN
IF TimeInSeconds& MOD LptIntervalVal = 0 THEN
LptIntervalDo = LptOnFlag
IF TimeInSeconds& MOD (LptIntervalVal * 10) = 0 THEN
LptHeadingDo = LptOnFlag
END IF
END IF
END IF





RETURN

ScheduleExecute:
IF DisplayIntervalDo = 1 THEN     'MAKE SURE TIME IS RIGHT *******




FOR i = 0 TO 127    'clear out last value area
MUXCON!(i, 5) = 0
NEXT i

'read a record
GET #1, TXXX%, kk
TXXX% = TXXX% + 1

'get  readings each channel
GOSUB LoadUpInBuf
READALL        'apply calibration constants and compute values
PRINTADC       'print it
DisplayIntervalDo = 0
END IF

IF PlotIntervalDo = 1 THEN
PutPlotsUp
PlotIntervalDo = 0
END IF


RETURN

SawToothIt:
'FineRampRate! is fraction of full scale/10  per ten seconds
MUXCON!(73, 0) = MUXCON!(73, 0) + FineRampRate!
MUXCON!(77, 0) = MUXCON!(77, 0) + TempRate!
IF MUXCON!(73, 0) > FineRampMin! THEN
MUXCON!(73, 0) = FineRampMin!
MUXCON!(73, 0) = TempMin!
END IF
IF MUXCON!(73, 0) < FineRampMax! THEN MUXCON!(73, 0) = FineRampMax!
AllDACLoad
RETURN

DisplayIntervalSet:
CALL GetNumber("Display Interval-Seconds", Avv!)
DisplayIntervalVal = Avv!
RETURN
WriteDiskIntervalSet:
CALL GetNumber("Disk Write Interval-Seconds", Avv!)
WriteDiskIntervalVal = Avv!
RETURN
PlotIntervalSet:
CALL GetNumber("Plot Interval-Seconds", Avv!)
PlotIntervalVal = Avv!
RETURN
LptIntervalSet:
CALL GetNumber("Lpt Print Interval-Seconds", Avv!)
LptIntervalVal% = Avv!
RETURN
CellBalanceTimeSet:
CALL GetNumber("Balance Time-Seconds", Avv!)
CellBalanceTimeVal = Avv!
RETURN
GasIntervalSet:
CALL GetNumber("GasInterval-Seconds", Avv!)
GasIntervalVal = Avv!
RETURN
PrintMuxLabels:
FOR i = 0 TO 127
LPRINT i;
LPRINT TAB(5);
LPRINT MUXNAME$(i, 0);
LPRINT TAB(15);
LPRINT MUXNAME$(i, 1)
NEXT i
RETURN

PlotDataSave:
OPEN "LEV.DAT" FOR OUTPUT AS #2
FOR i = 0 TO 71
FOR J = 0 TO 220
WRITE #2, LastEvents!(i, J)
NEXT J
NEXT i
CLOSE #2
RETURN
RestorePlotData:
OPEN "LEV.DAT" FOR INPUT AS #2
FOR i = 0 TO 71
FOR J = 0 TO 220
INPUT #2, LastEvents!(i, J)
NEXT J
NEXT i
CLOSE #2
RETURN
EnterComment:
LOCATE 10, 1
PRINT "Enter Comment "
INPUT Comment$
RETURN

LoadUpOutBuf:  'load up data type for random data out
kk.Datexx$ = DATE$
kk.Timexx$ = TIME$
kk.Comxx$ = Comment$
kk.Eventxx& = TimeInSeconds&
kk.WX00! = Gasx!    'these are spares.  note, use only for raw data taken
kk.WX01! = LastEvents!(33, 0)
kk.WX02! = 0
kk.WX03! = 0
kk.WX04! = 0
kk.WX05! = 0
kk.WX06! = 0
kk.WX07! = 0
kk.WI00% = 0
kk.WI01% = 0
kk.WI02% = 0
kk.WI03% = 0
kk.WW00% = MUXCON!(0, 5)
kk.WW01% = MUXCON!(1, 5)
kk.WW02% = MUXCON!(2, 5)
kk.WW03% = MUXCON!(3, 5)
kk.WW04% = MUXCON!(4, 5)
kk.WW05% = MUXCON!(5, 5)
kk.WW06% = MUXCON!(6, 5)
kk.WW07% = MUXCON!(7, 5)
kk.WW08% = MUXCON!(8, 5)
kk.WW09% = MUXCON!(9, 5)
kk.WW10% = MUXCON!(10, 5)
kk.WW11% = MUXCON!(11, 5)
kk.WW12% = MUXCON!(12, 5)
kk.WW13% = MUXCON!(13, 5)
kk.WW14% = MUXCON!(14, 5)
kk.WW15% = MUXCON!(15, 5)
kk.WW16% = MUXCON!(16, 5)
kk.WW17% = MUXCON!(17, 5)
kk.WW18% = MUXCON!(18, 5)
kk.WW19% = MUXCON!(19, 5)
kk.WW20% = MUXCON!(20, 5)
kk.WW21% = MUXCON!(21, 5)
kk.WW22% = MUXCON!(22, 5)
kk.WW23% = MUXCON!(23, 5)
kk.WW24% = MUXCON!(24, 5)
kk.WW25% = MUXCON!(25, 5)
kk.WW26% = MUXCON!(26, 5)
kk.WW27% = MUXCON!(27, 5)
kk.WW28% = MUXCON!(28, 5)
kk.WW29% = MUXCON!(29, 5)
kk.WW30% = MUXCON!(30, 5)
kk.WW31% = MUXCON!(31, 5)
kk.WW32% = MUXCON!(32, 5)
kk.WW33% = MUXCON!(33, 5)
kk.WW34% = MUXCON!(34, 5)
kk.WW35% = MUXCON!(35, 5)
kk.WW36% = MUXCON!(36, 5)
kk.WW37% = MUXCON!(37, 5)
kk.WW38% = MUXCON!(38, 5)
kk.WW39% = MUXCON!(39, 5)
kk.WW40% = MUXCON!(40, 5)
kk.WW41% = MUXCON!(41, 5)
kk.WW42% = MUXCON!(42, 5)
kk.WW43% = MUXCON!(43, 5)
kk.WW44% = MUXCON!(44, 5)
kk.WW45% = MUXCON!(45, 5)
kk.WW46% = MUXCON!(46, 5)
kk.WW47% = MUXCON!(47, 5)
kk.WW48% = MUXCON!(48, 5)
kk.WW49% = MUXCON!(49, 5)
kk.WW50% = MUXCON!(50, 5)
kk.WW51% = MUXCON!(51, 5)
kk.WW52% = MUXCON!(52, 5)
kk.WW53% = MUXCON!(53, 5)
kk.WW54% = MUXCON!(54, 5)
kk.WW55% = MUXCON!(55, 5)
kk.WW56% = MUXCON!(56, 5)
kk.WW57% = MUXCON!(57, 5)
kk.WW58% = MUXCON!(58, 5)
kk.WW59% = MUXCON!(59, 5)
kk.WW60% = MUXCON!(60, 5)
kk.WW61% = MUXCON!(61, 5)
kk.WW62% = MUXCON!(62, 5)
kk.WW63% = MUXCON!(63, 5)
RETURN


LoadUpInBuf:  'load up data type for random data out
Datexx$ = kk.Datexx$
Timexx$ = kk.Timexx$
Comment$ = kk.Comxx$
TimeInSeconds& = kk.Eventxx&
Gasx! = kk.WX00!   'these are spares.  note, use only for raw data taken
LastEvents!(33, 0) = kk.WX01!
MUXCON!(0, 5) = kk.WW00%
MUXCON!(1, 5) = kk.WW01%
MUXCON!(2, 5) = kk.WW02%
MUXCON!(3, 5) = kk.WW03%
MUXCON!(4, 5) = kk.WW04%
MUXCON!(5, 5) = kk.WW05%
MUXCON!(6, 5) = kk.WW06%
MUXCON!(7, 5) = kk.WW07%
MUXCON!(8, 5) = kk.WW08%
MUXCON!(9, 5) = kk.WW09%
MUXCON!(10, 5) = kk.WW10%
MUXCON!(11, 5) = kk.WW11%
MUXCON!(12, 5) = kk.WW12%
MUXCON!(13, 5) = kk.WW13%
MUXCON!(14, 5) = kk.WW14%
MUXCON!(15, 5) = kk.WW15%
MUXCON!(16, 5) = kk.WW16%
MUXCON!(17, 5) = kk.WW17%
MUXCON!(18, 5) = kk.WW18%
MUXCON!(19, 5) = kk.WW19%
MUXCON!(20, 5) = kk.WW20%
MUXCON!(21, 5) = kk.WW21%
MUXCON!(22, 5) = kk.WW22%
MUXCON!(23, 5) = kk.WW23%
MUXCON!(24, 5) = kk.WW24%
MUXCON!(25, 5) = kk.WW25%
MUXCON!(26, 5) = kk.WW26%
MUXCON!(27, 5) = kk.WW27%
MUXCON!(28, 5) = kk.WW28%
MUXCON!(29, 5) = kk.WW29%
MUXCON!(30, 5) = kk.WW30%
MUXCON!(31, 5) = kk.WW31%
MUXCON!(32, 5) = kk.WW32%
MUXCON!(33, 5) = kk.WW33%
MUXCON!(34, 5) = kk.WW34%
MUXCON!(35, 5) = kk.WW35%
MUXCON!(36, 5) = kk.WW36%
MUXCON!(37, 5) = kk.WW37%
MUXCON!(38, 5) = kk.WW38%
MUXCON!(39, 5) = kk.WW39%
MUXCON!(40, 5) = kk.WW40%
MUXCON!(41, 5) = kk.WW41%
MUXCON!(42, 5) = kk.WW42%
MUXCON!(43, 5) = kk.WW43%
MUXCON!(44, 5) = kk.WW44%
MUXCON!(45, 5) = kk.WW45%
MUXCON!(46, 5) = kk.WW46%
MUXCON!(47, 5) = kk.WW47%
MUXCON!(48, 5) = kk.WW48%
MUXCON!(49, 5) = kk.WW49%
MUXCON!(50, 5) = kk.WW50%
MUXCON!(51, 5) = kk.WW51%
MUXCON!(52, 5) = kk.WW52%
MUXCON!(53, 5) = kk.WW53%
MUXCON!(54, 5) = kk.WW54%
MUXCON!(55, 5) = kk.WW55%
MUXCON!(56, 5) = kk.WW56%
MUXCON!(57, 5) = kk.WW57%
MUXCON!(58, 5) = kk.WW58%
MUXCON!(59, 5) = kk.WW59%
MUXCON!(60, 5) = kk.WW60%
MUXCON!(61, 5) = kk.WW61%
MUXCON!(62, 5) = kk.WW62%
MUXCON!(63, 5) = kk.WW63%
RETURN

SUB GasIt (Gasx!) STATIC
SHARED StepCount!
'StepCount! = Gasx! * 70
Speed! = .1
'FOO: CALL GETADC(63, V%)'factor is 300 aprox counts per step
'PRINT V%
'GOTO FOO
'EXIT SUB
'motor A AGas=12
'motor B AGas=13
'motor C AGas=14
'motor D AGas=15
Done = 0
Countv = 0
'LOCATE 30, 30
'PRINT V%, StepCount!
DO UNTIL Done = 1
IF Countv > 50 THEN EXIT SUB
CALL GETADC(63, V%) 'factor is 300 aprox counts per step
'LOCATE 20, 40
'PRINT V%
SELECT CASE V%
CASE IS > 5700
Speed! = .005
Dir = 1
GOSUB Stepit
'Gasx! = StepCount! / 70
CASE IS > 4100
Speed! = .04
Dir = 1
GOSUB Stepit
CASE IS > 3720
Speed! = .1
Dir = 1
GOSUB Stepit
Done = 1
Gasx! = StepCount! / 70
CASE IS < 3300
Dir = 0
Speed! = .005
GOSUB Stepit
CASE IS < 3680  'back up to go forward
Dir = 0
Speed! = .02
FOR i = 1 TO 20' 50
GOSUB Stepit
NEXT i
CASE ELSE
'BEEP
Done = 1
Gasx! = StepCount! / 70
END SELECT
'Gasx! = StepCount! / 70
LOCATE 40, 1
PRINT USING "Gas = ###.##"; Gasx!
PRINT V%, StepCount!
LOOP
EXIT SUB
Stepit:
Countv = Countv + 1
CALL TIMEX(Speed!)
SELECT CASE Dir
CASE 0                 'set for up count
COLOR 5, 0
OUT &H300, 13    'set pulse path
OUT &H301, 0           'pulse for up
StepCount! = StepCount! - 1
CASE 1                 'set for down count
COLOR 3, 0
OUT &H300, 14    'set for down count
OUT &H301, 0           'pulse for down
StepCount! = StepCount! + 1
END SELECT
OUT &H300, 15 ' select the motor
OUT &H301, 0 'pulse it
RETURN
END SUB

'READS ALL THE VALUES INTO ADC
SUB READALL STATIC
MoveBlockDown  'to make room for new readings
SOUND 200, 2


FOR i = 0 TO 63
LastEvents!(i, 0) = ((MUXCON!(i, 5) / 32768!) * MUXCON!(i, 1)) - MUXCON!(i, 0)'convert to volts
NEXT i

PowerIntoCal1! = LastEvents!(16, 0) * (LastEvents!(43, 0) - LastEvents!(55, 0))'Drive Into Anode
PowerIntoCal2! = LastEvents!(8, 0) * (LastEvents!(44, 0) - LastEvents!(55, 0))'Drive Into Heater Bottom
PowerIntoCal3! = LastEvents!(18, 0) * (LastEvents!(41, 0) - LastEvents!(55, 0))'Drive Into Cathode Top
PowerIntoCal4! = 0'LastEvents!(19, 0) * (LastEvents!(40, 0) - LastEvents!(55, 0))'Drive Into Cathode Bottom
PowerIntoCal5! = 0'LastEvents!(17, 0) * (LastEvents!(42, 0) - LastEvents!(55, 0))'Drive Into Dummy
PowerIntoCal6! = 0'LastEvents!(0, 0) * (LastEvents!(45, 0) - LastEvents!(55, 0)) 'Drive Into Cat Heater
PowerIntoCal7! = 0'((-.5 - LastEvents!(33, 0)) / 6) * .952'tec loss power
PowerIntoCal8! = 0'LastEvents!(18, 0) * (LastEvents!(43, 0) - LastEvents!(41, 0)) * .003'cell power correction
PowerIntoCal9! = 0' -((LastEvents!(70, 1) - LastEvents!(70, 2)) * 22.5) / DisplayIntervalVal'gas
PowerIntoCal10! = 0' -(LastEvents!(5, 0) - LastEvents!(6, 0) - 1.5) * .0165 'ambiant temp cor
LastEvents!(65, 0) = PowerIntoCal6!'display it in caathode imp slot
MUXCON!(64, 5) = PowerIntoCal1! + PowerIntoCal2! + PowerIntoCal3! + PowerIntoCal4! + PowerIntoCal5! + PowerIntoCal6! + PowerIntoCal7! + PowerIntoCal8! + PowerIntoCal9! + PowerIntoCal10!
LastEvents!(64, 0) = MUXCON!(64, 5)
JoulesIntoCal! = LastEvents!(64, 0) * DisplayIntervalVal
JoulesOutOfCal! = (.08113 * LastEvents!(5, 0) + 8.0966) * PowerOutOfCal! * DisplayIntervalVal * (-LastEvents!(1, 0)) + ((-TSPLLast! + LastEvents!(13, 0)) * 1950)
LastEvents!(69, 0) = LastEvents!(69, 0) + (-JoulesIntoCal! + JoulesOutOfCal!) / 1000
MUXCON!(69, 5) = LastEvents!(69, 0)
MUXCON!(66, 5) = PowerIntoCal5!
LastEvents!(66, 0) = MUXCON!(66, 5)
TSPLLast! = LastEvents!(13, 0)
MUXCON!(80, 5) = (LastEvents!(44, 0) - LastEvents!(43, 0)) * LastEvents!(8, 0)'Cell Heater Power
Temp1! = 0
FOR i = 0 TO 9
Temp1! = Temp1! + LastEvents!(64, i)   '64 is inst pwr
NEXT i
MUXCON!(67, 5) = Temp1! / 10       '67 is 10 sample average pwr
LastEvents!(67, 0) = MUXCON!(67, 5)
Temp1! = 0
noe = 50
FOR i = 0 TO (noe - 1)
Temp1! = Temp1! + LastEvents!(64, i)
NEXT i
MUXCON!(68, 5) = Temp1! / noe      '68 is number of events (noe) sample average pwr
LastEvents!(68, 0) = MUXCON!(68, 5)
Temp1! = MUXCON!(68, 5)
Temp2! = 0
FOR i = 0 TO (noe - 1)
Temp2! = Temp2! + (LastEvents!(64, i) - Temp1!) ^ 2
NEXT i
LastEvents!(71, 0) = SQR(Temp2! / noe)
SOUND 400, 1
EXIT SUB


END SUB

