
'
' THIS MODULE CONTAINS ALL THE FIRMED UP SUBROUTINES
'
'
'$INCLUDE: 'general.bi'
'$INCLUDE: 'mouse.bi'
'$INCLUDE: 'menu.bi'
'$INCLUDE: 'window.bi'
'$INCLUDE: 'CFDECS.bi'
DEFINT A-Z
'

SUB AllDACLoad STATIC
FOR i = 72 TO 79
VF! = MUXCON!(i, 0) * 3276.8 'convert to unipolar
IF VF! < -32768 THEN VF! = -32768
IF VF! > 32767 THEN VF! = 32767
V = VF!
CALL SETDAC(i, V)
NEXT i
END SUB

SUB CheckMainFileName (FileSpec$, fileName$, fileExt$) STATIC
    ' =======================================================================
    ' Make sure its a valid file name
    ' =======================================================================

    delimit = INSTR(FileSpec$, ".")

    IF delimit THEN
        fileName$ = LEFT$(FileSpec$, delimit - 1)
        fileExt$ = ""
    ELSE
        fileName$ = FileSpec$
        fileExt$ = ""
    END IF

    IF LEN(FileSpec$) = 0 OR LEN(fileName$) > 8 OR LEN(fileExt$) > 3 THEN
        WindowClose 1
        junk = Alert(4, "You didn't enter a valid file specification.", 10, 15, 12, 62, "OK", "", "")
        fileName$ = ""
        EXIT SUB
    END IF


END SUB

SUB ColorDisplay
    DisplayType = TRUE
    MouseHide
    MenuSetState 2, 1, 2
    MenuSetState 2, 2, 1
    SetupDesktop
    MenuShow
    MouseShow
END SUB

SUB DACChannelSetup STATIC

    ' =======================================================================
    ' Open Window, write text, and open button and edit field
    ' =======================================================================
    REDIM aa$(1 TO 8)
    REDIM ab$(1 TO 8)
    REDIM ac$(1 TO 8)
    MOFF = 71
    FOR i = 1 TO 8
    aa$(i) = MUXNAME$(i + MOFF, 0)
    ab$(i) = "DAC" + RIGHT$(STR$(i + MOFF), 2) + " " + MUXNAME$(i + MOFF, 0)
    ac$(i) = MUXNAME$(i + MOFF, 1)
    ad$(i) = STR$(MUXCON!(i + MOFF, 0))
    NEXT i

    x = 0

    x = ListBox(ab$(), 8)
    IF x = 0 THEN EXIT SUB

    WindowOpen 1, 4, 4, 15, 70, 0, 7, 0, 7, 15, FALSE, FALSE, FALSE, TRUE, 1, ""

    WindowLocate 2, 2
    WindowPrint 2, "Short Symbol Name:"
    WindowBox 1, 22, 3, 31

    WindowLocate 5, 2
    WindowPrint 2, "Long Symbol Name:"
    WindowBox 4, 22, 6, 66

    WindowLocate 8, 2
    WindowPrint 2, "DAC Set Voltage:"
    WindowBox 7, 22, 9, 46


    EditFieldOpen 1, aa$(x), 2, 23, 0, 0, 8, 7
    EditFieldOpen 2, ac$(x), 5, 23, 0, 0, 42, 41
    EditFieldOpen 3, ad$(x), 8, 23, 0, 0, 23, 22

    WindowLine 11
    ButtonOpen 1, 2, "OK", 12, 17, 0, 0, 1
    ButtonOpen 2, 2, "CANCEL", 12, 30, 0, 0, 1

    ' =======================================================================
    ' Set initial state + go into main loop
    ' =======================================================================

    currButton = 0
    currEditField = 1

    ExitFlag = FALSE

    WHILE NOT ExitFlag
        WindowDo currButton, currEditField
        SELECT CASE Dialog(0)
            CASE 1, 6                       'Button, or Enter, exit loop
                ExitFlag = TRUE
            CASE 2                          'EditField, switch to edit field
                currButton = 0
                currEditField = 1
            CASE 7, 8                       'tab and backTab, flip/flop state
                IF currButton = 2 THEN
                    currButton = 0
                    currEditField = 1
                ELSEIF currEditField = 1 THEN
                    currButton = 0
                    currEditField = 2
                ELSEIF currEditField = 2 THEN
                    currButton = 0
                    currEditField = 3
                ELSEIF currEditField = 3 THEN
                     currButton = 1
                     currEditField = 0
                ELSE
                    currButton = 2
                    currEditField = 0
                END IF
            CASE 14                         'space - if on button then exit
                IF currButton = 1 THEN
                    ExitFlag = TRUE
                END IF
            CASE 9                          'escape
                WindowClose 1
                EXIT SUB
            CASE ELSE
        END SELECT
    WEND

    ' =======================================================================
    ' Assign the variable before closing the window, and close the window
    ' =======================================================================
    SELECT CASE currButton
    CASE 1
    'Enter the changed and edited values here
    MUXNAME$(x + MOFF, 0) = EditFieldInquire$(1)
    MUXNAME$(x + MOFF, 1) = EditFieldInquire$(2)
    MUXCON!(x + MOFF, 0) = VAL(EditFieldInquire$(3))
    CASE 2
    CASE ELSE
    END SELECT
    WindowClose 1


END SUB

SUB GETADC (P, V%) STATIC
' THIS READS THE VOLTAGE ENTERING PORT P INTO V AS A SIXTEEN BIT NUMBER
' P MUST BE IN THE RANGE OF 0-63  DEFINATIONS IN CF.INC
Test = 0
IF Test = 1 THEN
        count& = count& + 1
        OddEven = count& MOD 2
        SELECT CASE OddEven
        'VT& = 65535! * RND(3) - 32768              'FOR TEST
        CASE 0
        VT& = SIN(count& / 500) * 32767!
        CASE 1
        VT& = COS(count& / 800) * 32767!
        END SELECT
        V% = VT&
       EXIT SUB
ELSE
END IF
        MB = INT(P / 16)        'GET MULTIPLEXER #
        DB = P AND &HF          'GET ADDRESS
        IF MB = 0 THEN OUT &H30D, &H10 + DB     'SELECT MUX
        IF MB = 1 THEN OUT &H30D, &H20 + DB
        IF MB = 2 THEN OUT &H30D, &H40 + DB
        IF MB = 3 THEN OUT &H30D, &H80 + DB
        
        STOPFLAG = 1000
        DO
        TF& = INP(&H30E)
        TRACKFLAG& = TF& AND &H4
        IF TRACKFLAG& = 1 THEN TRACKFLAG& = 0 ELSE TRACKFLAG& = 1
        STOPFLAG = STOPFLAG - 1
        IF STOPFLAG < 1 THEN TRACKFLAG& = 1: SOUND 800, 1: LOCATE 23, 1: PRINT "DATA NEVER ACQUIRED"
        LOOP UNTIL TRACKFLAG& = 1
        OUT &H30E, 0                            'START ADC
        STOPFLAG = 1000
        SELECT CASE P
        CASE 0 TO 63
          DO
           G& = INP(&H30E)                         'GET STATUS
           GS& = G& AND &H40
           STOPFLAG = STOPFLAG - 1
           IF STOPFLAG < 1 THEN GS& = 0: SOUND 1000, 1: LOCATE 23, 1: PRINT "NEVER DONE"'FORCE AN EXIT TO STOP PROGRAM HANG
          LOOP UNTIL GS& = 0
        CASE ELSE
            BEEP                                    'ERROR EXIT
            PRINT "CHANNEL #"; P; " IS ILLEGAL"
        END SELECT
        OUT &H30D, &H10                          'LEAVE MUX AT 0

        GSF& = G& AND &H4                     'WHICH BYTE IS IT
        SELECT CASE GSF&
        CASE 0
        L& = INP(&H30D)
        H& = INP(&H30D)
        LOCATE 23, 1
        LBF! = LBF! + 1
        CASE 4
        H& = INP(&H30D)
        L& = INP(&H30D)
        LOCATE 22, 1
        HBF! = HBF! + 1
        PRINT "High Byte First"; HBF!
        PRINT "Low Byte First"; LBF!
        CASE ELSE
        END '***** REMOVE THIS LATER
        END SELECT
        VT& = 32768 - (H& * 256 + L&)              ' COMPUTE READING
'
'        LOCATE 20, 1
'        PRINT H&, L&
'        PRINT VT&
'        PRINT "STATUS"; G&
'        CALL TIMEX(.2)
        IF VT& > 32767 THEN VT& = 32767
        IF VT& < -32767 THEN VT& = -32768
        V% = VT&
END SUB

SUB GetDatFileName STATIC
    ' =======================================================================
    ' Assign the variable before closing the window, and close the window
    ' =======================================================================

    FileSpec$ = "*.CON"
    FileCount = GetFileCount(FileSpec$)

    IF FileCount THEN

        REDIM FileList$(FileCount)

    ELSE

        WindowClose 1
        junk = Alert(4, "No .CON File Available - Must Have One to Operate", 10, 10, 12, 70, "OK", "", "")
        EXIT SUB
    END IF
   
    FileList$(1) = DIR$(FileSpec$)
   
    FOR Indx = 2 TO FileCount
        FileList$(Indx) = DIR$
    NEXT Indx
    x = 0
    x = ListBox(FileList$(), UBOUND(FileList$))
    IF x > 0 THEN
    SetupFileNameT$ = FileList$(x)
    ELSE
    END IF
    WindowClose 1
END SUB

FUNCTION GetFileCount (FileSpec$)
    count = 0
    fileName$ = DIR$(FileSpec$)
    DO WHILE fileName$ <> ""
        count = count + 1
        fileName$ = DIR$
    LOOP
    GetFileCount = count
END FUNCTION

SUB GetLiteral (labelv$, entryv$) STATIC
    ' =======================================================================
    ' Open Window, write text, and open button and edit field
    ' =======================================================================

    WindowOpen 1, 8, 20, 13, 70, 0, 7, 0, 7, 15, FALSE, FALSE, FALSE, TRUE, 1, ""

    WindowLocate 2, 2
    WindowPrint 2, labelv$
    WindowBox 1, 24, 3, 48

    EditFieldOpen 1, "", 2, 25, 0, 0, 23, 22
    WindowLine 5
    ButtonOpen 1, 2, "OK", 6, 13, 0, 0, 1
    ButtonOpen 2, 1, "Cancel", 6, 31, 0, 0, 1

    ' =======================================================================
    ' Set initial state + go into main loop
    ' =======================================================================

    currButton = 0
    currEditField = 1

    ExitFlag = FALSE

    WHILE NOT ExitFlag
        WindowDo currButton, currEditField
        SELECT CASE Dialog(0)
            CASE 1, 6                       'Button, or Enter, exit loop
                ExitFlag = TRUE
            CASE 2                          'EditField, switch to edit field
                currButton = 0
                currEditField = 1
            CASE 7, 8                       'tab and backTab, flip/flop state
                IF currButton = 1 THEN
                    currButton = 2
                    currEditField = 0
                ELSEIF currButton = 2 THEN
                    currButton = 0
                    currEditField = 1
                ELSE
                    currButton = 1
                    currEditField = 0
                END IF
            CASE 14                         'space - if on button then exit
                IF currButton = 1 THEN
                    ExitFlag = TRUE
                END IF
            CASE 9                          'escape
                WindowClose 1
                EXIT SUB
            CASE ELSE
        END SELECT
    WEND

    ' =======================================================================
    ' Assign the variable before closing the window, and close the window
    ' =======================================================================
    SELECT CASE currButton
    CASE 1
    entryv$ = EditFieldInquire$(1)
    CASE ELSE
    END SELECT
    WindowClose 1

END SUB

SUB GetNumber (Labelb$, entryv!) STATIC
CALL GetLiteral(Labelb$, entryl$)
entryv! = VAL(entryl$)
END SUB

SUB HeadingPrint STATIC
LPRINT DATE$, TIME$, TimeInSeconds&
REDIM Pp(0 TO 7)
FOR i = 0 TO 71
SELECT CASE MUXCON!(i, 4)
CASE 2                  'green
Pp(0) = i
CASE 3                  'cyan
Pp(1) = i
CASE 5                  'magenta
Pp(2) = i
CASE 6                  'brown
Pp(3) = i
CASE 11                 'lt cyan
Pp(4) = i
CASE 12                 'lt red
Pp(5) = i
CASE 14                 'yellow
Pp(6) = i
CASE 15                 'lt white
Pp(7) = i
END SELECT
NEXT i
LPRINT TAB(2);
FOR i = 0 TO 7
    LPRINT MUXNAME$(Pp(i), 0);
    LPRINT TAB(10 * (i + 1));
NEXT i
LPRINT
END SUB

SUB LoadConstants STATIC
'READS THE MUX CHANNEL SHORT AND LONG NAMES AND THE OFFSET AND
'SCALE FACTOR CALIBRATION CONSTANTS FROM THE FILE CFCONS.CON
REDIM MUXNAME$(0 TO 127, 0 TO 1)
REDIM MUXCON!(0 TO 127, 0 TO 7)
REDIM LastEvents!(0 TO 71, 0 TO 220)'create data storage matrix
OPEN SetupFileNameT$ FOR INPUT AS #2   'SAVE #1 FOR DATA OUTPUT
FOR i = 0 TO 127
FOR J = 0 TO 1
INPUT #2, MUXNAME$(i, J)
NEXT J
FOR J = 0 TO 7
INPUT #2, MUXCON!(i, J)
NEXT J
NEXT i
CLOSE #2
LOADED = 1
END SUB

SUB LoadMatrix STATIC
LOCATE 10, 1
INPUT "Enter ADC Scale Factor "; ap!
FOR i = 0 TO 63
MUXCON!(i, 0) = 0
MUXCON!(i, 1) = ap!
MUXCON!(i, 2) = 0
MUXCON!(i, 3) = 20
MUXCON!(i, 4) = 0
NEXT i
END SUB

SUB LoadNewConstants STATIC
Old$ = SetupFileNameT$
GetDatFileName
IF SetupFileNameT$ = Old$ THEN
ELSE
LoadConstants
END IF
END SUB

SUB LTNAME (L%, N$)
'
' THIS CONVERTS THE LOCATION # IN L TO A NAME STRING IN N$
        DEVNAME$ = DEVNAME1$ + DEVNAME2$ + DEVNAME3$ + DEVNAME4$ + DEVNAME5$ + DEVNAME6$ + DEVNAME7$
        N$ = "ILLEGAL LOCATION"
        IF L < 0 THEN GOTO LTNE
        IF L > COOLERCD THEN GOTO LTNE
        N$ = MID$(DEVNAME$, 1 + L * (DEVNAMELEN), DEVNAMELEN)
LTNE:
END SUB

SUB ModifyConstants (MUXNAME$(), MUXCON!()) STATIC

    ' =======================================================================
    ' Open Window, write text, and open button and edit field
    ' =======================================================================
    REDIM aa$(1 TO 72)
    REDIM ab$(1 TO 72)
    REDIM ac$(1 TO 72)
    REDIM ad$(1 TO 72)
    REDIM ae$(1 TO 72)
    REDIM af$(1 TO 72)
    REDIM ag$(1 TO 72)
    FOR i = 1 TO 72
    aa$(i) = MUXNAME$(i - 1, 0)
    ab$(i) = "CH" + RIGHT$(STR$(i - 1), 2) + " " + MUXNAME$(i - 1, 0)
    ac$(i) = MUXNAME$(i - 1, 1)
    ad$(i) = STR$(MUXCON!(i - 1, 0))
    ae$(i) = STR$(MUXCON!(i - 1, 1))
    af$(i) = STR$(MUXCON!(i - 1, 2))
    ag$(i) = STR$(MUXCON!(i - 1, 3))
    NEXT i

    x = 0

    x = ListBox(ab$(), 72)
    IF x = 0 THEN EXIT SUB

    WindowOpen 1, 4, 4, 18, 70, 0, 7, 0, 7, 15, FALSE, FALSE, FALSE, TRUE, 1, ""

    WindowLocate 2, 2
    WindowPrint 2, "Short Symbol Name:"
    WindowBox 1, 22, 3, 31

    WindowLocate 5, 2
    WindowPrint 2, "Long Symbol Name:"
    WindowBox 4, 22, 6, 66

    WindowLocate 8, 2
    WindowPrint 2, "Offset Voltage:"
    WindowBox 7, 22, 9, 46

    WindowLocate 11, 2
    WindowPrint 2, "Scale Factor:"
    WindowLocate 12, 2
    WindowPrint 2, "Volts Full Scale"
    WindowBox 10, 22, 12, 46

    EditFieldOpen 1, aa$(x), 2, 23, 0, 0, 8, 7
    EditFieldOpen 2, ac$(x), 5, 23, 0, 0, 42, 41
    EditFieldOpen 3, ad$(x), 8, 23, 0, 0, 23, 22
    EditFieldOpen 4, ae$(x), 11, 23, 0, 0, 23, 22

    WindowLine 14
    ButtonOpen 1, 2, "OK", 15, 10, 0, 0, 1
    ButtonOpen 2, 2, "CANCEL", 15, 30, 0, 0, 1
    ButtonOpen 3, 2, "PLOT", 15, 50, 0, 0, 1
    ' =======================================================================
    ' Set initial state + go into main loop
    ' ======================================================================

    currButton = 3
    currEditField = 0

    ExitFlag = FALSE

    WHILE NOT ExitFlag
        WindowDo currButton, currEditField
        SELECT CASE Dialog(0)
            CASE 1, 6                       'Button, or Enter, exit loop
                ExitFlag = TRUE
            CASE 2                          'EditField, switch to edit field
                currButton = 0
                currEditField = 1
            CASE 7, 8                       'tab and backTab, flip/flop state
                IF currButton = 3 THEN
                    currButton = 0
                    currEditField = 1
                ELSEIF currEditField = 1 THEN
                    currButton = 0
                    currEditField = 2
                ELSEIF currEditField = 2 THEN
                    currButton = 0
                    currEditField = 3
                ELSEIF currEditField = 3 THEN
                    currButton = 0
                    currEditField = 4
                ELSEIF currEditField = 4 THEN
                     currButton = 1
                     currEditField = 0
                ELSEIF currButton = 1 THEN
                     currButton = 2
                     currEditField = 0
                ELSE
                    currButton = 3
                    currEditField = 0
                END IF
            CASE 14                         'space - if on button then exit
                IF currButton = 1 THEN
                    ExitFlag = TRUE
                END IF
            CASE 9                          'escape
                WindowClose 1
                EXIT SUB
            CASE ELSE
        END SELECT
    WEND

    ' =======================================================================
    ' Assign the variable before closing the window, and close the window
    ' =======================================================================
    SELECT CASE currButton
    CASE 1
    MUXNAME$(x - 1, 0) = EditFieldInquire$(1)
    MUXNAME$(x - 1, 1) = EditFieldInquire$(2)
    MUXCON!(x - 1, 0) = VAL(EditFieldInquire$(3))
    'offset in volts
    MUXCON!(x - 1, 1) = VAL(EditFieldInquire$(4))
    'scale factor in volts for 32768 counts
    CASE 2
    CASE 3
    MUXNAME$(x - 1, 0) = EditFieldInquire$(1)
    MUXNAME$(x - 1, 1) = EditFieldInquire$(2)
    MUXCON!(x - 1, 0) = VAL(EditFieldInquire$(3))
    'offset in volts
    MUXCON!(x - 1, 1) = VAL(EditFieldInquire$(4))
    'scale factor in volts for 32768 counts
    WindowClose 1
    WindowOpen 1, 4, 4, 18, 70, 0, 7, 0, 7, 15, FALSE, FALSE, FALSE, TRUE, 1, ""

    WindowLocate 2, 2
    WindowPrint 2, "Short Symbol Name: " + MUXNAME$(x - 1, 0)
    
    WindowLocate 4, 2
    WindowPrint 2, "Long Symbol Name: " + MUXNAME$(x - 1, 1)
    
    WindowLocate 6, 2
    WindowPrint 2, "Center Screen"
    WindowLocate 7, 2
    WindowPrint 2, "Plot Value"
    WindowLocate 8, 2
    WindowPrint 2, "in Volts"
    WindowBox 6, 22, 8, 46

    WindowLocate 10, 2
    WindowPrint 2, "Full Scale"
    WindowLocate 11, 2
    WindowPrint 2, "Plot Value"
    WindowLocate 12, 2
    WindowPrint 2, "in Volts"
    WindowBox 10, 22, 12, 46

    EditFieldOpen 1, af$(x), 7, 23, 0, 0, 23, 22
    EditFieldOpen 2, ag$(x), 11, 23, 0, 0, 23, 22

    WindowLine 14
    ButtonOpen 1, 2, "OK", 15, 10, 0, 0, 1
    ButtonOpen 2, 2, "CANCEL", 15, 30, 0, 0, 1
    ButtonOpen 3, 2, "AUTO SCALE", 15, 50, 0, 0, 1
    ' =======================================================================
    ' Set initial state + go into main loop
    ' ======================================================================

    currButton = 0
    currEditField = 1

    ExitFlag = FALSE

    WHILE NOT ExitFlag
        WindowDo currButton, currEditField
        SELECT CASE Dialog(0)
            CASE 1, 6                       'Button, or Enter, exit loop
                ExitFlag = TRUE
            CASE 2                          'EditField, switch to edit field
                currButton = 0
                currEditField = 1
            CASE 7, 8                       'tab and backTab, flip/flop state
                IF currButton = 3 THEN
                    currButton = 0
                    currEditField = 1
                ELSEIF currEditField = 1 THEN
                    currButton = 0
                    currEditField = 2
                ELSEIF currEditField = 2 THEN
                     currButton = 1
                     currEditField = 0
                ELSEIF currButton = 1 THEN
                     currButton = 2
                     currEditField = 0
                ELSEIF currButton = 2 THEN
                    currButton = 3
                    currEditField = 0
                ELSE
                END IF
            CASE 14                         'space - if on button then exit
                IF currButton = 1 THEN
                    ExitFlag = TRUE
                END IF
            CASE 9                          'escape
                WindowClose 1
                EXIT SUB
            CASE ELSE
        END SELECT
    WEND

    ' =======================================================================
    ' Assign the variable before closing the window, and close the window
    ' =======================================================================
    SELECT CASE currButton
    CASE 1    'use entered scale factors
    MUXCON!(x - 1, 2) = VAL(EditFieldInquire$(1))
    'offset voltage
    MUXCON!(x - 1, 3) = VAL(EditFieldInquire$(2))
    'pead to peak full scale voltage
    GOSUB ColorSelect
    IF ColorX > -1 THEN MUXCON!(x - 1, 4) = ColorX
    CASE 2    'do nothing
    CASE 3    'auto scale
    MUXCON!(x - 1, 3) = 1 'put auto scale routine here
    GOSUB ColorSelect
    CASE ELSE
    END SELECT
    CASE ELSE
    END SELECT
    WindowClose 1
EXIT SUB

ColorSelect:
WindowClose 1
px = ListBox(ScreenColors$(), 16)
ColorX = px - 1
RETURN

END SUB

SUB MonoDisplay
    DisplayType = FALSE
    MouseHide
    MenuSetState 2, 1, 1
    MenuSetState 2, 2, 2
    SetupDesktop
    MenuShow
    MouseShow
END SUB

'Moves the last n events stored down one to make space for a new event
SUB MoveBlockDown STATIC
FOR J = 0 TO 71
FOR i = 220 TO 1 STEP -1
LastEvents!(J, i) = LastEvents!(J, i - 1)
NEXT i
NEXT J
END SUB

SUB NAMETL (N$, L%)
' THIS CONVERTS THE NAME IN N$ TO A LOCATION NUMBER
'
        A = LEN(N$)
        IF A < 10 THEN F$ = MID$("          ", 1, 10 - A) ELSE F$ = ""
        L = INSTR(1, DEVNAME$, N$ + F$)
        IF L > 0 THEN L = INT(L / DEVNAMELEN) ELSE L = -1
'
END SUB

SUB PRINTADC STATIC
'PRINTS OUT THE ADC VALUES ON THE FIRST 16 SCREEN ROWS
FOR i = 0 TO 17
LOCATE i + 1, 1
FOR J = 0 TO 3
Q = 18 * J + i
IF J = 0 THEN TSP = O ELSE TSP = 1
IF DisplayType = TRUE THEN
SELECT CASE MUXCON!(Q, 4)
CASE 0, 7
COLOR 7
CASE ELSE
COLOR MUXCON!(Q, 4)
END SELECT
ELSE
END IF
PRINT TAB((20 * J) + TSP);
PRINT RIGHT$(STR$(Q), 2);
PRINT TAB((20 * J) + 4);
PRINT MUXNAME$(Q, 0);
PRINT TAB((20 * J) + 11);
PRINT USING "###.####"; LastEvents!(Q, 0);
NEXT J
PRINT
NEXT i
END SUB

'Puts the labels of the items ploted in the unused screen area.
SUB PutPlotsUp
PlotCount = 18
LINE (178, 149)-(639, 349), 0, BF
LabelNumber = 0
LinesFS = 100'63'Screen Lines for full scale voltage
CenterLine = 249 '287'line for zero plot voltage
FOR i = 0 TO 71
  IF MUXCON!(i, 4) > 0 THEN
    PlotCount = PlotCount + 1
    IF PlotCount < 31 THEN   'allow all 14 available colors - white for not ploted
      LOCATE PlotCount, 1
      IF DisplayType = TRUE THEN
      COLOR MUXCON!(i, 4)
      END IF
      PRINT USING "Sc###.### Off###.###"; MUXCON!(i, 3); MUXCON!(i, 2);
    END IF
    FOR J = 0 TO 220
    IF MUXCON!(i, 3) = 0 THEN MUXCON!(i, 3) = 1
      PlotPoint! = (-(LastEvents!(i, J) / MUXCON!(i, 3)) * LinesFS) + ((MUXCON!(i, 2) / MUXCON!(i, 3)) * LinesFS) + CenterLine
      IF PlotPoint! > 349 THEN PlotPoint! = 349
      IF PlotPoint! < 0 THEN PlotPoint! = 0
      'plotted point is centered at line CenterLine scaled then shifted
      OddEven = MUXCON!(i, 4) MOD 2
      PSET (639 - ((2 * J) + OddEven), PlotPoint!), MUXCON!(i, 4)
    NEXT J
  END IF
NEXT i
FOR i = 198 TO 639 STEP 60
FOR J = 149 TO 349 STEP 10
PSET (i, J), 15
NEXT J
NEXT i
PlotCount = PlotCount + 1
LOCATE PlotCount, 1
COLOR 7
PRINT DATE$; " "; TIME$
PRINT USING "Time      = #######"; TimeInSeconds&
PRINT USING "JoulesIn  = ####.##"; JoulesIntoCal!
PRINT USING "JoulesOut = ####.##"; JoulesOutOfCal!
PRINT USING "JSumOfRun = ####.##"; LastEvents!(69, 0)
PRINT USING "RefrigPwr = ##.####"; PowerOutOfCal!
END SUB

SUB SamplesToAverage STATIC
CALL GetNumber("NumberOfSamples", A!)
NumberOfSamples% = A!

END SUB

SUB SaveConstants STATIC
'WRITES THE MUX CHANNEL SHORT AND LONG NAMES AND THE OFFSET AND
'SCALE FACTOR CALIBRATION CONSTANTS TO THE FILE CFCONS.CON
IF LOADED = 0 THEN EXIT SUB
CALL GetLiteral("Enter File Name", FileSpec$)
CALL CheckMainFileName(FileSpec$, fileName$, fileExt$)
IF fileName$ = "" THEN EXIT SUB
SetupFileNameT$ = fileName$ + ".CON"
OPEN SetupFileNameT$ FOR OUTPUT AS #2   'SAVE #1 FOR DATA OUTPUT
FOR i = 0 TO 127
FOR J = 0 TO 1
WRITE #2, MUXNAME$(i, J)
NEXT J
FOR J = 0 TO 7
WRITE #2, MUXCON!(i, J)
NEXT J
NEXT i
CLOSE #2
END SUB

SUB SelectedPrint STATIC
REDIM Pp(0 TO 7)
FOR i = 0 TO 71
SELECT CASE MUXCON!(i, 4)
CASE 2                  'green
Pp(0) = i
CASE 3                  'cyan
Pp(1) = i
CASE 5                  'magenta
Pp(2) = i
CASE 6                  'brown
Pp(3) = i
CASE 11                 'lt cyan
Pp(4) = i
CASE 12                 'lt red
Pp(5) = i
CASE 14                 'yellow
Pp(6) = i
CASE 15                 'lt white
Pp(7) = i
END SELECT
NEXT i
FOR i = 0 TO 7
    LPRINT USING "###.####"; LastEvents!(Pp(i), 0);
    LPRINT TAB(10 * (i + 1));
NEXT i
LPRINT
END SUB

SUB SETDAC (D, V)
' THIS SETS THE DAC 70-77 NAMED TO THE 16 BIT VALUE IN V
' DAC DEFINATIONS ARE IN FILE CF.INC
        DM = 0                          'ASSUME FAILIER
        IF D = 72 THEN DM = &H1          ' TEST FOR VALID DAC #
        IF D = 73 THEN DM = &H2
        IF D = 74 THEN DM = &H4
        IF D = 75 THEN DM = &H8
        IF D = 76 THEN DM = &H10
        IF D = 77 THEN DM = &H20
        IF D = 78 THEN DM = &H40
        IF D = 79 THEN DM = &H80
        IF DM = 0 THEN GOTO SETDF       ' TEST FOR FAILER
        OUT &H308, DM                   ' GOOD SELECT DAC
        OUT &H309, &H1                  ' SELECT HIGH BYTE
        OUT &H30A, INT(V / 256)         'SEND HIGH BYTE
        OUT &H309, &H6                  'SELECT LOW BYTE + TRANSFER
        OUT &H30A, INT(V - 256 * (INT(V / 256)))' SEND LOW BYTE
        OUT &H309, &H0                  'SELECT NADA
        OUT &H308, &H0                  'DESELECT DAC
        GOTO SETDF1
'
SETDF:  BEEP
        PRINT " ONLY DACS 70-77 ARE AVAIBLE YOU USED #"; D
        BEEP

SETDF1:                                 ' EXIT

END SUB

DEFSNG A-Z
SUB SetupDesktop STATIC

    MouseHide

    WIDTH , 25

    IF DisplayType THEN
        COLOR 15, 1      'Color
    ELSE
        COLOR 15, 0      'Monochrome
    END IF
    CLS

    FOR A = 2 TO 80 STEP 4
        FOR b = 2 TO 25 STEP 2
            LOCATE b, A
            PRINT CHR$(250);
        NEXT b
    NEXT A

    MouseShow
END SUB

DEFINT A-Z
SUB SetupFileName STATIC
CALL GetLiteral("File Name for Constants", Avc$)
SetupFileNameT$ = LEFT$(Avc$, 8) + ".CON"
END SUB

SUB SetupMenu

    MenuSet 1, 0, 1, "Run", 1
    MenuSet 1, 1, 1, "Continue               ", 1
    MenuSet 1, 3, 1, "Start Run              ", 1
    MenuSet 1, 4, 1, "End Run                ", 1
    MenuSet 1, 5, 1, "Change DisK            ", 8
    MenuSet 1, 10, 1, "eXit                  ", 2
                          
    MenuSet 2, 0, 1, "Channels", 1
    MenuSet 2, 1, 1, "SaveConstants          ", 1
    MenuSet 2, 2, 1, "ModifyConstants        ", 1
    MenuSet 2, 3, 1, "GetConstants           ", 1
    MenuSet 2, 4, 1, "NameSetupFile          ", 1
    MenuSet 2, 5, 1, "PlotDataSave           ", 1
    MenuSet 2, 6, 1, "RestorePlotData        ", 1


    MenuSet 3, 0, 1, "Jobs", 1
    MenuSet 3, 1, 1, "RandomHeatChange-Secs  " + STR$(RandomIntervalVal&), 1
    MenuSet 3, 2, 1, "ComputeConstantsMatrix ", 1
    MenuSet 3, 3, 1, "PrintMuxLabels         ", 1
    MenuSet 3, 4, 1, "StartEnergyBalance     ", 1
    MenuSet 3, 5, 1, "MonoMonitorSet         ", 1
    MenuSet 3, 6, 1, "InvertCellCurrent      ", 1
    MenuSet 3, 7, 1, "Adjust PowerOutOfCal   ", 1
    MenuSet 3, 8, 1, "JouleSumReset          ", 1
    MenuSet 3, 9, 1, "GasReset               ", 1
    MenuSet 3, 10, 1, "SawTooth              " + STR$(SawTooth%), 4
    MenuSet 3, 11, 1, "HiLo                  " + STR$(HiLo%), 1
    
    MenuSet 4, 0, 1, "Output", 1
    MenuSet 4, 1, 1, "Lpt On/Off      " + STR$(LptOnFlag), 1
    MenuSet 4, 2, 1, "Floppy On/Off = " + LogFileName$, 1
    MenuSet 4, 3, 1, "Display On/Off  " + STR$(DisplayOnFlag), 1
    MenuSet 4, 4, 1, "Plot On/Off     " + STR$(PlotOnFlag), 1
    MenuSet 4, 5, 1, "EnterComment    ", 1
    MenuSet 4, 6, 1, "Gas On/Off      " + STR$(GasOnFlag), 1
    MenuSet 4, 7, 1, "AutoTrack On/Off" + STR$(AutoTrackOnFlag), 1
    MenuSet 4, 8, 1, "WriteFastGas    ", 1

    MenuSet 5, 0, 1, "Analyze                ", 1
    MenuSet 5, 1, 1, "PlotChannel            ", 1

    MenuSet 6, 0, 1, "SetDAC", 1
    MenuSet 6, 1, 1, "DACChannelSetup        ", 1
    MenuSet 6, 2, 1, "AllDACLoad             ", 1
    MenuSet 6, 3, 1, "SingleDACLoad-NotWorking ", 1

    MenuSet 7, 0, 1, "WorkSet", 1
    MenuSet 7, 1, 1, "NumberOfSamplesToAverage " + STR$(NumberOfSamples), 1
    MenuSet 7, 2, 1, "DisplayIntervalSet       " + STR$(DisplayIntervalVal), 1
    MenuSet 7, 3, 1, "PlotIntervalSet          " + STR$(PlotIntervalVal), 1
    MenuSet 7, 4, 1, "WriteDiskIntervalSet     " + STR$(WriteDiskIntervalVal), 1
    MenuSet 7, 5, 1, "LptIntervalSet           " + STR$(LptIntervalVal), 1
    MenuSet 7, 6, 1, "CellBalanceTimeSet       " + STR$(CellBalanceTimeVal), 1
    MenuSet 7, 7, 1, "GasIntervalSet           " + STR$(GasIntervalVal), 1

    

    IF NOT DisplayType THEN
       MenuColor 0, 7, 15, 8, 7, 0, 15   'Best for monochrome and colors
    ELSE
        MenuColor 0, 7, 4, 8, 15, 0, 12   'Best for color
    END IF

    MenuPreProcess

END SUB

SUB TIMEX (A!) STATIC
              IF A! < 0 THEN
              TIMEXD! = TIMER
              FOR i! = 1 TO 10000!
              NEXT i!
              TIMEXE! = TIMER
              IF TIMEXE! < TIMEXD! THEN TIMEXE! = TIMEXE! + 86400
              TIMEXF! = TIMEXE! - TIMEXD!
              TIMFAC! = 10000 / TIMEXF!
              PRINT "ITERATIONS PER SECOND= "; TIMFAC!
              ELSE
              LOOPX! = A! * TIMFAC!
              FOR i! = 1 TO LOOPX!
              NEXT i!
              END IF

END SUB

